; ----Compressor----

SetCompressor /SOLID lzma

;---Definitions----

!define SNAME "LocateOpener"

;----Includes----

!include "FileFunc.nsh"
!insertmacro "Getparameters"
!define StrContains '!insertmacro "_StrContainsConstructor"'
!define StrReplaceV4 `!insertmacro StrReplaceV4`
!include "LogicLib.nsh"
!define Explode "!insertmacro Explode"

;-----Runtime switches----
CRCCheck off
AutoCloseWindow True
SilentInstall silent
WindowIcon off
XPSTYLE on 

;-----Set basic information-----

Name "${SNAME}"
Icon "${SNAME}.ico"
Caption "${SNAME}"
OutFile "..\${SNAME}.exe"

;-----Version Information------

LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"

VIProductVersion "0.1.0.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" " tpr 2008"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.1"

!macro Explode Length Separator String
    Push    `${Separator}`
    Push    `${String}`
    Call    Explode
    Pop     `${Length}`
!macroend

!macro _StrContainsConstructor OUT NEEDLE HAYSTACK
  Push "${HAYSTACK}"
  Push "${NEEDLE}"
  Call StrContains
  Pop "${OUT}"
!macroend

!macro StrReplaceV4 Var Replace With In
 Push ${Var1}
 Push ${Var2}
 Push `${Replace}`
 Push `${With}`
 Push `${In}`
 Call StrReplaceV4
 Pop `${Var}`
 Pop ${Var2}
 Pop ${Var1}
!macroend

!define Var0 $R0
!define Var1 $R1
!define Var2 $R2
!define Var3 $R3
!define Var4 $R4
!define Var5 $R5
!define Var6 $R6
!define Var7 $R7
!define Var8 $R8

Var params
Var userapp
Var commandline
Var extension
Var trid_cmd
Var line
Var result
Var no_extension
Var UserOnlineTool
Var url

Section "ini"

	IfFileExists "$EXEDIR\${SNAME}.ini" +3
	SetOutPath "$EXEDIR"
	File "${SNAME}.ini"
	
	IfFileExists "$EXEDIR\readme.txt" +3
	SetOutPath "$EXEDIR"
	File "readme.txt"

SectionEnd

Section "shell integrate"

	${Getparameters} $params
	
		StrCmp $params "" 0 check_params
		
			messagebox::show MB_DEFBUTTON4|MB_TOPMOST " ${SNAME}" \
			"0,103" \	
			'Would you like to install or remove ${SNAME}?' \
			"&Install" "&Remove" "&Cancel" "&Help"
			
			Pop $R1		
			StrCmp $R1 1 install
			StrCmp $R1 2 remove
			StrCmp $R1 3 0
			StrCmp $R1 4 help
		
		Abort
		
		help:
		ExecShell "open" "$EXEDIR\readme.txt"
		Abort
		
	check_params:
	
		${StrContains} $0 "/install" $params
		StrCmp $0 "/install" install
		
		${StrContains} $0 "/remove" $params
		StrCmp $0 "/remove" remove
		
		goto continue
		
		install:
			WriteRegStr HKCR "*\shell\${SNAME}" "" "${SNAME}"
			WriteRegStr HKCR "*\shell\${SNAME}\command" "" '"$EXEDIR\${SNAME}.exe" %1'
			Abort
			
		remove:
			DeleteRegKey HKCR "*\shell\${SNAME}"
			Abort
	
	continue:
		${StrReplaceV4} $params "/install" "" "$params"
		${StrReplaceV4} $params "/remove" "" "$params"
		
		Push $params
		Call Trim
		Pop $params
	
SectionEnd


Section "Main"

Push $params
Call Trim	;trim leading and trailing whitespace 
Pop $params

		Push "$params"
		Push "\"
		Call GetAfterChar
		Pop $no_extension


		Push "$params"
		Call GetFileExt
		Pop $extension	; $extension = "extension"

/*
		${Switch} "$extension"
			${Case} "exe"
			${Case} "cmd"
			${Case} "bat"
				Abort
				${Break}
		${EndSwitch}
*/	

StrCmp "$extension" "" 0 fes_ask

			messagebox::show MB_DEFBUTTON3|MB_TOPMOST ' ${SNAME} - file without extension "$no_extension"' \
			"0,103" \	
			'"$params"$\nhas no extension.$\n$\nWould you like to scan with TrID?' \
			"&Yes" "&Help" "&No, thanks"
			
			Pop $R1		
			StrCmp $R1 1 trid
			StrCmp $R1 2 help
			StrCmp $R1 3 0
			Abort
  
  		trid:
	
			IfFileExists "$EXEDIR\TrID\trid.exe" check_defs
				messagebox::show MB_DEFBUTTON2|MB_TOPMOST ' ${SNAME}' \
				"0,103" \	
				"Error - TrID.exe not found!" \
				"&OK" "&Help"
				
				Pop $0
				StrCmp $0 2 help
				Abort
			
		
			check_defs:
			
				IfFileExists "$EXEDIR\TrID\TrIDDefs.TRD" trid_cmd
				messagebox::show MB_DEFBUTTON2|MB_TOPMOST ' ${SNAME}' \
				"0,103" \	
				"Error - TrID definitions (TrIDDefs.TRD) not found!" \
				"&OK" "&Help"
				
				Pop $0
				StrCmp $0 2 help
				Abort
			
			trid_cmd:

			ReadINIStr $trid_cmd "$EXEDIR\${SNAME}.ini" "TrID" "trid_cmd"
			
			StrCmp $trid_cmd "" no_tridcmd
				
				Exec '$EXEDIR\TrID\trid.exe "$params" $trid_cmd'
				Abort
				


		no_tridcmd:
		
			Delete "$TEMP\TrID.txt"

			ReadEnvStr $R0 COMSPEC

			nsExec::Exec '"$R0" /c $EXEDIR\TrID\trid.exe "$params" $trid_cmd >> $TEMP\TrID.txt'

			  StrCpy $result ""
			  StrCpy $line 7
			  
				${For} $9 1 10
					Push $line ;line number to read from
					Push "$TEMP\TrID.txt"
					
					Call ReadFileLine
					Pop $R8
					StrCpy $result $result$R8
					IntOp $line $line + 1
				${Next}
				
					Push $result
					Call Trim
					Pop $result
				
				StrCmp $result "" 0 +2
				StrCpy $result "Sorry, this file can't be analyzed."
				
					; check if there's any % in the results
					StrCpy $R1 "&Help"
					${StrContains} $1 "%" "$result"
					StrCmp $1 "" 0 +2
					StrCpy $R1 "Check &online"
			
			messagebox::show MB_DEFBUTTON3|MB_TOPMOST ' ${SNAME} - TrID scan results for "$no_extension"' "0,103" "$result" "Cop&y to clipboard" "&Append extension" "&Cancel"  "$R1"
			
			Pop $0
			
			StrCmp $0 3 0 +2
				Abort
			StrCmp $0 1 clipboard 0
			StrCmp $0 2 rename 0
			StrCmp $0 4 0 +3
				StrCmp $R1 "Check &online" fes
				goto help
				
			Abort

	clipboard:
		Push "$result"
		Call CopyToClipboard
		Abort
  
	rename:
		nsExec::Exec '"$R0" /c $EXEDIR\TrID\trid.exe "$params" -ae'
		Abort
  
  
  help:
	  ExecShell "open" "$EXEDIR\readme.txt"
	  Abort
  
	Delete "$TEMP\TrID.txt"
	Abort
	
fes_ask:
  
  ReadRegStr $0 HKCR ".$extension" ""
  StrCmp $0 "" ask_fes
  
  ReadRegStr $0 HKCR "$0\shell\open\command" ""
  
  
  ; check if extension has a path in open command in registry
  
  ${StrContains} $1 ":\" "$0"
  StrCmp $1 "" 0 get_application
  
	messagebox::show MB_DEFBUTTON3|MB_TOPMOST ' ${SNAME}' "0,103" "Sorry, associated application can't be located." "&OK" "&Scan with TrID" "&Cancel"
  
	Pop $7
	StrCmp $7 2 trid
	Abort
  
  get_application:
  
		Push "$0"
		Call GetInQuotes
		Pop $R0 ; = quotes

		${StrContains} $R9 ":\" $R0
		StrCmp $R9 ":\" check_userapp
		
			Push '"$R0"' ; divider str
			Push "$0" ; input string
			Call GetLastPart
			Pop $R1 ; last part
			; Pop $R0 ; first part "hell"
		
		
		${StrReplaceV4} "$0" '"$R0"' "" "$0"
		${StrReplaceV4} "$0" "$R0" "" "$0"
		${StrReplaceV4} "$0" "$R1" "" "$0"
		
			Push $0
			Call Trim
			Pop $R0
		 
		check_userapp:
		  ReadINIStr $userapp "$EXEDIR\${SNAME}.ini" "${SNAME}" "UserApp"
			StrCmp "$userapp" "" explorer
		  ReadINIStr $commandline "$EXEDIR\${SNAME}.ini" "${SNAME}" "commandline"
		  
				${StrContains} $0 ":\" $userapp
					StrCmp $0 "" relative_path exec_userapp
						relative_path:
						GetFullPathName $userapp "$EXEDIR\$userapp"
						
				exec_userapp:
				
				IfFileExists "$userapp" +3
				messagebox::show MB_DEFBUTTON1|MB_TOPMOST ' ${SNAME}' "0,103" "User defined application not found!$\nPlease check your configuration." "&OK"
				Abort

		  
				Exec '"$userapp" $commandline$R0"'
				Abort
		  
			explorer:
				Exec '"$WINDIR\explorer.exe" /select,$R0'
		  
	Abort
  
  ask_fes:
  
  		ReadINIStr $3 "$EXEDIR\${SNAME}.ini" "LocateOpener" "UserOnlineTool"
  		
  			   ${Explode}  $0  "|" $3
			    StrCpy $5 1 $0
					Pop $2
					StrCmp $2 "" ask
					
					Push $2
					Call Trim
					Pop $UserOnlineTool
  		
				StrCpy $5 2 $0
					Pop $url
					
					${StrReplaceV4} "$url" "%EXTENSION%" "$extension" "$url"
  		

  		
	ask:
	
		StrCmp $UserOnlineTool "" 0 +2
		StrCpy $UserOnlineTool "File Extension Seeker"
		
		StrCmp $url "" 0 +2
		StrCpy $url "http://file-extension.net/seeker/file_extension_$extension"
	
		messagebox::show MB_DEFBUTTON3|MB_TOPMOST " ${SNAME} - unknown extension (.$extension)" \
		"0,103" \	
		'"$params"$\nhas unknown extension (.$extension).$\n$\nWould you like to check file online at $UserOnlineTool?' \
		"&Yes" "&Help" "&No" "Scan with &TrID"
		
		Pop $R1		
		StrCmp $R1 1 fes
		StrCmp $R1 2 help
		StrCmp $R1 3 +2
		StrCmp $R1 4 trid
		Abort
 
  fes:
  ExecShell "open" "$url"
 
  Abort		
	
SectionEnd

; StrContains
; This function does a case sensitive searches for an occurrence of a substring in a string. 
; It returns the substring if it is found. 
; Otherwise it returns null(""). 
; Written by kenglish_hi
; Adapted from StrReplace written by dandaman32
 
Var STR_HAYSTACK
Var STR_NEEDLE
Var STR_CONTAINS_VAR_1
Var STR_CONTAINS_VAR_2
Var STR_CONTAINS_VAR_3
Var STR_CONTAINS_VAR_4
Var STR_RETURN_VAR
 
Function StrContains
  Exch $STR_NEEDLE
  Exch 1
  Exch $STR_HAYSTACK
  ; Uncomment to debug
  ;MessageBox MB_OK 'STR_NEEDLE = $STR_NEEDLE STR_HAYSTACK = $STR_HAYSTACK '
    StrCpy $STR_RETURN_VAR ""
    StrCpy $STR_CONTAINS_VAR_1 -1
    StrLen $STR_CONTAINS_VAR_2 $STR_NEEDLE
    StrLen $STR_CONTAINS_VAR_4 $STR_HAYSTACK
    loop:
      IntOp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_1 + 1
      StrCpy $STR_CONTAINS_VAR_3 $STR_HAYSTACK $STR_CONTAINS_VAR_2 $STR_CONTAINS_VAR_1
      StrCmp $STR_CONTAINS_VAR_3 $STR_NEEDLE found
      StrCmp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_4 done
      Goto loop
    found:
      StrCpy $STR_RETURN_VAR $STR_NEEDLE
      Goto done
    done:
   Pop $STR_NEEDLE ;Prevent "invalid opcode" errors and keep the
   Exch $STR_RETURN_VAR  
FunctionEnd

Function StrReplaceV4
Exch ${Var0} #in
Exch 1
Exch ${Var1} #with
Exch 2
Exch ${Var2} #replace
Push ${Var3}
Push ${Var4}
Push ${Var5}
Push ${Var6}
Push ${Var7}
Push ${Var8}
 
 StrCpy ${Var3} -1
 StrLen ${Var5} ${Var0}
 StrLen ${Var6} ${Var1}
 StrLen ${Var7} ${Var2}
 Loop:
  IntOp ${Var3} ${Var3} + 1
  StrCpy ${Var4} ${Var0} ${Var7} ${Var3}
  StrCmp ${Var3} ${Var5} End
  StrCmp ${Var4} ${Var2} 0 Loop
 
   StrCpy ${Var4} ${Var0} ${Var3}
   IntOp ${Var8} ${Var3} + ${Var7}
   StrCpy ${Var8} ${Var0} "" ${Var8}
   StrCpy ${Var0} ${Var4}${Var1}${Var8}
   IntOp ${Var3} ${Var3} + ${Var6}
   IntOp ${Var3} ${Var3} - 1
   IntOp ${Var5} ${Var5} - ${Var7}
   IntOp ${Var5} ${Var5} + ${Var6}
 
 Goto Loop
 End:
 
Pop ${Var8}
Pop ${Var7}
Pop ${Var6}
Pop ${Var5}
Pop ${Var4}
Pop ${Var3}
Pop ${Var2}
Pop ${Var1}
Exch ${Var0} #out
FunctionEnd

Function Trim
	Exch $R1 ; Original string
	Push $R2
 
Loop:
	StrCpy $R2 "$R1" 1
	StrCmp "$R2" " " TrimLeft
	StrCmp "$R2" "$\r" TrimLeft
	StrCmp "$R2" "$\n" TrimLeft
	StrCmp "$R2" "$\t" TrimLeft
	GoTo Loop2
TrimLeft:	
	StrCpy $R1 "$R1" "" 1
	Goto Loop

Loop2:
	StrCpy $R2 "$R1" 1 -1
	StrCmp "$R2" " " TrimRight
	StrCmp "$R2" "$\r" TrimRight
	StrCmp "$R2" "$\n" TrimRight
	StrCmp "$R2" "$\t" TrimRight
	GoTo Done
TrimRight:	
	StrCpy $R1 "$R1" -1
	Goto Loop2
 
Done:
	Pop $R2
	Exch $R1
FunctionEnd

Function GetFileExt
  Exch $0 ; input string
  Push $1
  Push $2
  StrCpy $1 0
  loop:
    IntOp $1 $1 - 1
    StrCpy $2 $0 1 $1
    StrCmp $2 "" empty
    StrCmp $2 "\" empty
    StrCmp $2 "." found
    Goto loop
  empty:
    StrCpy $0 ""
    goto exit
  found:
    IntOp $1 $1 + 1
    StrCpy $0 $0 "" $1
  exit:
    Pop $2
    Pop $1
    Exch $0
FunctionEnd

Function GetInQuotes
Exch $R0
Push $R1
Push $R2
Push $R3
 
 StrCpy $R2 -1
 IntOp $R2 $R2 + 1
  StrCpy $R3 $R0 1 $R2
  StrCmp $R3 "" 0 +3
   StrCpy $R0 ""
   Goto Done
  StrCmp $R3 '"' 0 -5
 
 IntOp $R2 $R2 + 1
 StrCpy $R0 $R0 "" $R2
 
 StrCpy $R2 0
 IntOp $R2 $R2 + 1
  StrCpy $R3 $R0 1 $R2
  StrCmp $R3 "" 0 +3
   StrCpy $R0 ""
   Goto Done
  StrCmp $R3 '"' 0 -5
 
 StrCpy $R0 $R0 $R2
 Done:
 
Pop $R3
Pop $R2
Pop $R1
Exch $R0
FunctionEnd

Function ReadFileLine
Exch $0 ;file
Exch
Exch $1 ;line number
Push $2
Push $3
 
  FileOpen $2 $0 r
 StrCpy $3 0
 
Loop:
 IntOp $3 $3 + 1
  ClearErrors
  FileRead $2 $0
  IfErrors +2
 StrCmp $3 $1 0 loop
  FileClose $2
 
Pop $3
Pop $2
Pop $1
Exch $0
FunctionEnd
Function CopyToClipboard
Exch $0 ;input string
Push $1
Push $2
System::Call 'user32::OpenClipboard(i 0)'
System::Call 'user32::EmptyClipboard()'
StrLen $1 $0
IntOp $1 $1 + 1
System::Call 'kernel32::GlobalAlloc(i 2, i r1) i.r1'
System::Call 'kernel32::GlobalLock(i r1) i.r2'
System::Call 'kernel32::lstrcpyA(i r2, t r0)'
System::Call 'kernel32::GlobalUnlock(i r1)'
System::Call 'user32::SetClipboardData(i 1, i r1)'
System::Call 'user32::CloseClipboard()'
Pop $2
Pop $1
Pop $0
FunctionEnd

Function GetAfterChar
  Exch $0 ; chop char
  Exch
  Exch $1 ; input string
  Push $2
  Push $3
  StrCpy $2 0
  loop:
    IntOp $2 $2 - 1
    StrCpy $3 $1 1 $2
    StrCmp $3 "" 0 +3
      StrCpy $0 ""
      Goto exit2
    StrCmp $3 $0 exit1
    Goto loop
  exit1:
    IntOp $2 $2 + 1
    StrCpy $0 $1 "" $2
  exit2:
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; output
FunctionEnd

Function Explode
  ; Initialize variables
  Var /GLOBAL explString
  Var /GLOBAL explSeparator
  Var /GLOBAL explStrLen
  Var /GLOBAL explSepLen
  Var /GLOBAL explOffset
  Var /GLOBAL explTmp
  Var /GLOBAL explTmp2
  Var /GLOBAL explTmp3
  Var /GLOBAL explArrCount
  
  ; Get input from user
  Pop $explString
  Pop $explSeparator
  
  ; Calculates initial values
  StrLen $explStrLen $explString
  StrLen $explSepLen $explSeparator
  StrCpy $explArrCount 1
 
  ${If}   $explStrLen <= 1          ;   If we got a single character
  ${OrIf} $explSepLen > $explStrLen ;   or separator is larger than the string,
    Push    $explString             ;   then we return initial string with no change
    Push    1                       ;   and set array's length to 1
    Return
  ${EndIf}
  
  ; Set offset to the last symbol of the string
  StrCpy $explOffset $explStrLen
  IntOp  $explOffset $explOffset - 1
  
  ; Clear temp string to exclude the possibility of appearance of occasional data
  StrCpy $explTmp   ""
  StrCpy $explTmp2  ""
  StrCpy $explTmp3  ""
 
  ; Loop until the offset becomes negative
  ${Do}
    ;   If offset becomes negative, it is time to leave the function
    ${IfThen} $explOffset == -1 ${|} ${ExitDo} ${|}
    
    ;   Remove everything before and after the searched part ("TempStr")
    StrCpy $explTmp $explString $explSepLen $explOffset
 
    ${If} $explTmp == $explSeparator
        ;   Calculating offset to start copy from
        IntOp   $explTmp2 $explOffset + $explSepLen ;   Offset equals to the current offset plus length of separator
        StrCpy  $explTmp3 $explString "" $explTmp2
        
        Push    $explTmp3                           ;   Throwing array item to the stack
        IntOp   $explArrCount $explArrCount + 1     ;   Increasing array's counter
        
        StrCpy  $explString $explString $explOffset 0   ;   Cutting all characters beginning with the separator entry
        StrLen  $explStrLen $explString
    ${EndIf}
    
    ${If} $explOffset = 0                       ;   If the beginning of the line met and there is no separator,
                                                ;   copying the rest of the string
        ${If} $explSeparator == ""              ;   Fix for the empty separator
            IntOp   $explArrCount   $explArrCount - 1
        ${Else}
            Push    $explString
        ${EndIf}
    ${EndIf}
    
    IntOp   $explOffset $explOffset - 1
  ${Loop}
 
  Push $explArrCount
FunctionEnd

Function GetLastPart
Exch $R0 ; input
Exch
Exch $R1 ; divider str
Push $R2
Push $R3
Push $R4
Push $R5
 
 StrCpy $R2 -1
 StrLen $R4 $R0
 StrLen $R5 $R1
 Loop:
  IntOp $R2 $R2 + 1
  StrCpy $R3 $R0 $R5 $R2
  StrCmp $R3 $R1 Chop
  StrCmp $R2 $R4 0 Loop
   StrCpy $R0 ""
   StrCpy $R1 ""
   Goto Done
 Chop:
  StrCpy $R1 $R0 $R2
  IntOp $R2 $R2 + $R5
  StrCpy $R0 $R0 "" $R2
 Done:
 
Pop $R5
Pop $R4
Pop $R3
Pop $R2
Exch $R1 ; before
Exch
Exch $R0 ; after
FunctionEnd